GITTAG = $(VERSION)-$(RELEASE)
CVSROOT = $(shell cat CVS/Root)

VERSION = $(shell awk -F= '/^VERSION=/ { print $$2 }' $(TOPDIR)/mkinitrd)
export VERSION
RELEASE = $(shell awk '/^Release:/ { sub(/%\{\?dist\}/, ""); print $$2 }' $(TOPDIR)/mkinitrd.spec.in)
export RELEASE

LIB ?= lib
export LIB

ARCH := $(patsubst i%86,i386,$(shell uname -m))
ARCH := $(patsubst sparc%,sparc,$(ARCH))
ARCH := $(patsubst ppc%,ppc,$(ARCH))

CC = gcc
CFLAGS ?= -Wall -Werror -g -D_FORTIFY_SOURCE=2 -Wno-unused-function -fPIC \
	  -std=gnu99 -D_GNU_SOURCE=1
LDFLAGS ?= -Wl,--wrap,open,--wrap,fopen,--wrap,opendir,--wrap,socket \
	-Wl,--wrap,pipe,--wrap,mkdir,--wrap,access

mandir = usr/share/man

all:: $(TARGETS) subdirs

$(shell pwd)/version.h: $(TOPDIR)/mkinitrd $(TOPDIR)/Makefile.inc \
		$(TOPDIR)/Makefile $(shell pwd)/Makefile
	@echo making $(shell pwd)/version.h
	@echo '#ifdef VERSION' > version.h
	@echo '#undef VERSION' >> version.h
	@echo '#endif' >> version.h
	@echo '#define VERSION' \"$(VERSION)\" >> version.h

.PHONY:: subdirs $(SUBDIRS) staticlibs clean all
subdirs :: $(shell pwd)/version.h
subdirs ::
	@if [ -n "$(SUBDIRS)" ]; then \
	for n in $(SUBDIRS) ; do make -C $$n staticlibs || exit 1 ; done ; \
	for n in $(SUBDIRS) ; do make -C $$n all || exit 1 ; done ; \
	fi

staticlibs :: $(shell pwd)/version.h $(LIBS)

$(OBJECTS): %.o : %.c
	$(CC) $(CFLAGS) -c -o $@ $<

clean::
	rm -f $(TARGETS) *.o *.a version.h
	@for n in $(SUBDIRS); do make -C $$n clean ; done
